################################################################################
##
## Subversion file information - please do not edit this block
## $Rev: 888 $
## $Date: 2011-01-11 16:03:28 +0100 (Tue, 11 Jan 2011) $
## $Author: nash $
## $Id: indb2ldb.hfd.R 888 2011-01-11 15:03:28Z nash $
##
################################################################################

indb2ldb.hfd <-
function(indb=NA, fname="", LDBfname="", printLDB=TRUE, countryName="", maxO=max(indb$BirthOrder), minAge = 12, maxAge = 55) {
 if(all(is.na(indb))) {
  indb=indbLoad(fname);
  }
 indb=indb[indb$Lexis=='TL' | indb$Lexis=='TU',];
 minYear=min(indb$Year,na.rm=TRUE);
 maxYear=max(indb$Year,na.rm=TRUE);

 ldb=NULL;
 for (y in minYear:maxYear) {
  indby=indb[indb$Year==y,];
  age=minAge
  cohort=y-age;
  ldba=matrix(NA,1,maxO+1);
  for (bo in 0:maxO) {
    b=indby$Births[(indby$Age<age | (indby$Age==age & indby$Lexis=='TL')) & indby$BirthOrder==bo];
    if (length(b)>0) ldba[bo+1]=sum(b);
    }
  ldb=rbind(ldb,c(y, age, y-age,ldba))
#browser()
  ldba=matrix(NA,1,maxO+1);
  for (bo in 0:maxO) {
    b=indby$Births[indby$Age==age & indby$Lexis=='TU' & indby$BirthOrder==bo];
    if (length(b)>0) ldba[bo+1]=b;
    }
  ldb=rbind(ldb,c(y, age, y-age,ldba))
  for (age in (minAge+1):(maxAge-1)) {
    cohort=y-age;
    for (LE in c('TL','TU')) {
      ldba=matrix(NA,1,maxO+1);
#      tot=indby$Births[indby$Age==age & indby$Lexis==LE & indby$BirthOrder=='TOT']; #tot
#      if (length(tot)<1) tot=indby$Births[indby$Age==age & indby$Lexis==LE];
#      if (length(tot)>0) { ldba[1]=sum(tot);}
      for (bo in 0:maxO) {
        b=indby$Births[indby$Age==age & indby$Lexis==LE & indby$BirthOrder==bo];
        if (length(b)>0) ldba[bo+1]=b;
        }
 #     b=indby$Births[indby$Age==age & indby$Lexis==LE & indby$BirthOrder>=5];
 #     if (length(b)>0) ldba[6]=sum(b);
      ldb=rbind(ldb,c(y, age, y-age,ldba))
    }
  }
  age=maxAge
  cohort=y-age;
  ldba=matrix(NA,1,maxO + 1);
  for (bo in 0:maxO) {
    b=indby$Births[indby$Age==age & indby$Lexis=='TL' & indby$BirthOrder==bo];
    if (length(b)>0) ldba[bo+1]=b;
    }
  ldb=rbind(ldb,c(y, age, y-age,ldba))
  ldba=matrix(NA,1,maxO + 1);
  for (bo in 0:maxO) {
    b=indby$Births[(indby$Age>age | (indby$Age==age & indby$Lexis=='TU')) & indby$BirthOrder==bo];
    if (length(b)>0) ldba[bo+1]=sum(b);
    }
  ldb=rbind(ldb,c(y, age, y-age,ldba))
 }
 if(length(ldb[is.na(ldb[,4]),4])==1) {
    ldb[is.na(ldb[,4]),4]=sum(ldb[is.na(ldb[,4]),5:ncol(ldb)])
    }
 if(length(ldb[is.na(ldb[,4]),4])>1) {
    ldb[is.na(ldb[,4]),4]=rowSums(ldb[is.na(ldb[,4]),5:ncol(ldb)])
    }
 ldb[seq(2,length(ldb[,1]),2),3]=ldb[seq(2,length(ldb[,1]),2),3]-1;
 ldb=data.frame(ldb)
 names(ldb)<-c('Year','Age','Cohort','Total',if(maxO > 1) paste("B", 1:maxO, sep = ""));
 names(ldb)[ncol(ldb)] <- paste(names(ldb)[ncol(ldb)], "p", sep = "")
 
 if (printLDB) {
  if (LDBfname=="") LDBfname=paste(indb$PopName[1],"birthsTRw.txt",sep="");
  if (countryName=="") countryName=indb$PopName[1];
  cat(countryName, ', Live births by age and birth order, by Lexis triangles (1x1)\n', 'Last modified: ', date(),'\n\n',sep='', file=LDBfname)
  ldbp=cbind(Year = format(ldb[,1],digits=1,justify='right', width=4),
             Age = format(ldb[,2],digits=1,justify='right', width=3),
             Cohort = format(ldb[,3],digits=1,justify='right', width=6),
             sub("NA", " .", as.matrix(format(round(ldb[,4:ncol(ldb)],2),digits=4,justify='right',na.encode = FALSE, nsmall=2, width=10)), fixed = TRUE))
  cat('Year  Age  Cohort       Total', paste(format(names(ldb)[5:ncol(ldb)], width = 12, justify = "right"), collapse = ""), '\n',  append=TRUE, sep='', file=LDBfname); #to remomove warning message
  write.table(ldbp,file=LDBfname,sep="  ",col.names = FALSE, row.names=FALSE, quote=FALSE, append=TRUE, na=".");
 }

 return(ldb)
}

