################################################################################
##
## Subversion file information - please do not edit this block
## $Rev: 882 $
## $Date: 2011-01-10 09:06:33 +0100 (Mon, 10 Jan 2011) $
## $Author: nash $
## $Id: split5.births.phantom.R 882 2011-01-10 08:06:33Z nash $
##
################################################################################

split5.births.phantom <-
function(dta,exps,Lexis='RR',verbose=TRUE) {

# splits data using piece-wise cubic hermite interpolating polynomial spline

 years=unique(dta$Year);
 dta=dta[order(dta$Year,dta$Age,dta$Lexis),];
 dtaR=dta[dta$Age==300 | dta$Age==-1,];
 dta=dta[dta$Age!=300 & dta$Age!=-1,];
 dta$Lexis[dta$Lexis=='TU' & dta$AgeInt==100]='VV'
 dta$Age[dta$Lexis=='TL' & dta$AgeInt==-100]= dta$Age[dta$Lexis=='TL' & dta$AgeInt==-100]-1;
 dta$Lexis[dta$Lexis=='TL' & dta$AgeInt==-100]='VV'

 if (verbose) cat('5-year age groups and open age intervals\n')
 for (y in years) {
    dtay=dta[dta$Year==y,]
    if (length(dtay$Age[dtay$AgeInt!=1])==0) {
       dtaR=rbind(dtaR,dtay)
       }
    else {
      if (verbose && y %% 10 == 0) cat('\n')
      if (verbose) cat(y,' ')
      dtaRy=NULL
      if (length(unique(dtay$BirthOrder))>=5) {
        for (b in 0:max(dtay$BirthOrder)) {
         dtas <- dtay[dtay$BirthOrder==b,]
         dtas$Births[dtas$Births == 0 & (dtas$AgeInt == -100 | dtas$Age == min(dtas$Age[dtas$Age > -1]))] <- 1
         dtas=split5(dtas,exps[exps$Year==y,]);
         dtas=adjust(dtas,dtay[dtay$BirthOrder==b,])
         dtaRy=rbind(dtaRy,dtas)
         }
        dtaR=rbind(dtaR,indb.IPF(dtaRy[order(dtaRy$BirthOrder,dtaRy$Age),],dtay$Age[dtay$BirthOrder==0],dtay$Lexis[dtay$BirthOrder==0]));
       }
      else {
        dtas=split5(dtay[dtay$BirthOrder==0,],exps[exps$Year==y,]);
        dtas=adjust(dtas,dtay[dtay$BirthOrder==0,])
        dtaR=rbind(dtaR,dtas);
        } 
      }  
    }
 cat('\n');   
 return(dtaR[order(dtaR$Year,dtaR$BirthOrder,dtaR$Age),])
}

