%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%% Subversion file information - please do not edit this block
%% $Rev: 882 $
%% $Date: 2011-01-10 09:06:33 +0100 (Mon, 10 Jan 2011) $
%% $Author: nash $
%% $Id: hfdIndb2ldb-package.Rd 882 2011-01-10 08:06:33Z nash $
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{hfdIndb2ldb-package}
\alias{hfdIndb2ldb-package}
\alias{hfdIndb2ldb}
\docType{package}
\title{
  Production of Human Fertility Database LexisDB
}
\description{
  This package contains functions for calculation of the LexisDB for a
  Human Fertility Database population. Estimated female population
  exposure may be calculated based on population data and monthly births
  data, and births data may be transformed to a standard format of age
  range 12- to 55+, birth order range 1 to 5+ through aggregation
  and splitting as appropriate.
}
\details{
\tabular{ll}{
Package: \tab hfdIndb2ldb\cr
Type: \tab Package\cr
Version: \tab 0.0\cr
Date: \tab 0000-00-00\cr
License: \tab GPL (>= 2.0)\cr
LazyLoad: \tab yes\cr
}
}
\author{
Dmitri Jdanov \email{jdanov@demogr.mpg.de}, with modifications
by Edward Nash \email{nash@demogr.mpg.de}

Maintainer: Edward Nash \email{nash@demogr.mpg.de}
}
\references{
  Jasilioniene et al.: Methods Protocol for the Human Fertility Database.
  Available from \url{http://www.humanfertility.org} 
}
\keyword{ package }
\seealso{
  \code{\link{hfdIndbLoad}}, required for loading HFD births input file
}
\examples{
\dontrun{
# requires RUSbirths.txt and RUSmonthly.txt from HFD and fRUS.txt from HMD
dta <- indb.standard("RUSbirths.txt")
dta <- unk.unk(dta)
dta <- unk.bo(dta)
dta <- unk.age(dta)
dta <- unk.IPF(dta)
exps <- indbExposure("fRUS.txt", "RUSmonthly.txt", outfile = NA)
dta <- split5.births(dta, exps)
dta <- split1.births(dta, exps)
indb2ldb.hfd(dta, LDBfname = "RUSbirthsTRw.txt") 
}
}
